//+------------------------------------------------------------------+
//|                                                        skalp.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.01"
#property strict
//--- input parameters
input double   inLot       = 0.01;
input int      inTraling   = 200;
input bool     inStop      = true;
extern color   clText      = White;                  //Font color


//----    -------------------------------
int    prevBar;
int    gMG         = 87346538;
int    inTimeFrame = 60;
string gsAddToText = "4Frame";

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   prevBar=iBars(NULL,60);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   int iTF=60;
   if (prevBar!=iBars(NULL,inTimeFrame))
   {
      int iTT=fnTypeTrend();
      double dATRTP=iATR(NULL,inTimeFrame,12,0);
      double dATRSL=iATR(NULL,inTimeFrame,12,0);      
      double minstoplevel=(int)MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
      
      //double dLev=iHigh(NULL,60,1)-iLow(NULL,60,1);
      
      //if (!ExistPosition(gMG) && iTT>=0 && dATRSL>minstoplevel)
      if (!ExistPosition(gMG) && iTT>=0)
      {
         double tSL = 0;
         double tTP = 0;
         if (iTT==0)//BUY
         {              
            if (inStop)
            {
               tSL = Ask-dATRSL;
               tTP = Ask+dATRTP;            
            }        
            SetOrder(iTT,Ask,tSL,tTP,gMG);
         }
         
         if (iTT==1)//SELL 
         { 
            if (inStop)
            {
               tSL = Bid+dATRSL;
               tTP = Bid-dATRTP;            
            }      
            SetOrder(iTT,Bid,tSL,tTP,gMG);       
         }     
      }
      
   }
   prevBar=iBars(NULL,inTimeFrame);
   funTrailingPositions();
   
 // 
   string tsNameTypeBar = "";
   //---------------
   int tiTB=fnTypeBar(5,1);
   if (tiTB==1) tsNameTypeBar = "SELL";
   else 
      if (tiTB==0) tsNameTypeBar = "BUY";
      else tsNameTypeBar = "NONE";   
   funAddText(1,"Time Frame 5: "+tsNameTypeBar,clText);
   //---------------
   tiTB=fnTypeBar(15,1);
   if (tiTB==1) tsNameTypeBar = "SELL";
   else 
      if (tiTB==0) tsNameTypeBar = "BUY";
      else tsNameTypeBar = "NONE";   
   funAddText(2,"Time Frame 15: "+tsNameTypeBar,clText);
   //------------------
   tiTB=fnTypeBar(30,1);
   if (tiTB==1) tsNameTypeBar = "SELL";
   else 
      if (tiTB==0) tsNameTypeBar = "BUY";
      else tsNameTypeBar = "NONE";   
   funAddText(3,"Time Frame 30: "+tsNameTypeBar,clText);
   //-------------------
   tiTB=fnTypeBar(60,1);
   if (tiTB==1) tsNameTypeBar = "SELL";
   else 
      if (tiTB==0) tsNameTypeBar = "BUY";
      else tsNameTypeBar = "NONE";   
   funAddText(4,"Time Frame 60: "+tsNameTypeBar,clText);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                   |
//| :                                            |
//|-1 -                                            |
//|0 -                                                        |
//|1 -                                                        |
//+------------------------------------------------------------------+
int fnTypeTrend() 
  {
    if (fnTypeBar(5,1)==0 && fnTypeBar(15,1)==0 && fnTypeBar(30,1)==0 && fnTypeBar(60,1)==0) return(0);
    if (fnTypeBar(5,1)==1 && fnTypeBar(15,1)==1 && fnTypeBar(30,1)==1 && fnTypeBar(60,1)==1) return(1);
   
    return(-1);
  }
  
//+------------------------------------------------------------------+
//| 
//|-1 -                                                     |
//| 0 -                                                 |
//| 1 -                                               |
//+------------------------------------------------------------------+
int fnTypeBar(
                ENUM_TIMEFRAMES tf, //                
                int nBar // 
               ) 
  {
  int Exist=-1;
  double dATRSL=iATR(NULL,tf,21,nBar); 
  int minstoplevel=(int)MarketInfo(Symbol(),MODE_STOPLEVEL);
  double dTA=MathAbs(iClose(NULL,tf,nBar)-iOpen(NULL,tf,nBar));
  int tiSaze = (int)(dTA/Point);
  if (dTA>Point)
  {
   if (iClose(NULL,tf,nBar)>iOpen(NULL,tf,nBar)) Exist=0;
   if (iClose(NULL,tf,nBar)<iOpen(NULL,tf,nBar)) Exist=1;
  }
  return(Exist);
  }

//+------------------------------------------------------------------+
//|                                                   |
//| :                                                       |
//|   op     -                                               |
//|   pp     -                                                   |
//|   ldStop -                                                   |
//|   ldTake -                                                   |
//|   mn     - MAGIC                                                 |
//+------------------------------------------------------------------+
void SetOrder(int op,double pp,double ldStop,double ldTake,int mn) 
  {
   //color  clOpen;
   string lsComm="Skalp";

   //if(op==OP_BUYSTOP) clOpen=clOpenBuy;
   //else clOpen=clOpenSell;
   pp=NormalizeDouble(pp,Digits);
   ldStop=NormalizeDouble(ldStop,Digits);
   ldTake=NormalizeDouble(ldTake,Digits);
   int ticket = OrderSend(Symbol(),op,inLot,pp,0,ldStop,ldTake,lsComm,mn,0,clrGreen);
   if(ticket<0)
     {
      Print("OrderSend    #",GetLastError());
      Print(":",op," TP:",ldTake,"SL:",ldStop);
     }
   else 
      {
       Print(" OrderSend  ");
      
      }
   //if(UseSound) PlaySound(NameFileSound);
  }
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
bool ExistPosition(int mn) 
  {
   bool Exist=False;
   for(int i=0; i<OrdersTotal(); i++) 
     {
      if(OrderSelect(i,SELECT_BY_POS)) 
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn) 
           {
            if(OrderType()==OP_BUY || OrderType()==OP_SELL) 
              {
               Exist=True; break;
              }
           }
        }
     }
   return(Exist);
  }
  //+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void funTrailingPositions()
  {
   double tdPrStLs;
   int minstoplevel=(int)MarketInfo(Symbol(),MODE_STOPLEVEL);
//---
   for(int i=0; i<OrdersTotal(); i++)
     {
      bool tbBezUb=false;
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==gMG)
           {
            //-----------------------------------------------------------------------------------------------------------------

            if(OrderType()==OP_BUY)
              {
               tdPrStLs=NormalizeDouble(Bid-inTraling*Point,Digits);
               //if(OrderStopLoss()<OrderOpenPrice() && Bid>OrderOpenPrice()) tdPrStLs=OrderOpenPrice();
              
               //tPr=NormalizeDouble(Bid-(MarketInfo(Symbol(),MODE_STOPLEVEL)+1)*Point,Digits);
               if(tdPrStLs>OrderStopLoss())
                  if(tdPrStLs>=OrderOpenPrice())
                     funModifyStopLoss(OrderTicket(),OrderOpenPrice(),OrderTakeProfit(),tdPrStLs);
              }

            if(OrderType()==OP_SELL)
              {
               tdPrStLs=NormalizeDouble(Ask+inTraling*Point,Digits);
               //if(OrderStopLoss()>OrderOpenPrice() && Ask<OrderOpenPrice()) tdPrStLs=OrderOpenPrice();
              
               //tPr=NormalizeDouble(Ask+(MarketInfo(Symbol(),MODE_STOPLEVEL)+1)*Point,Digits);
               if(tdPrStLs<OrderStopLoss())
                  if(tdPrStLs<=OrderOpenPrice())
                     funModifyStopLoss(OrderTicket(),OrderOpenPrice(),OrderTakeProfit(),tdPrStLs);
              }
            //-----------------------------------------------------------------------------------------------------------------
           }
        }
     }
  }
  //+------------------------------------------------------------------+
//|   StopLoss                                          |
//+------------------------------------------------------------------+
void funModifyStopLoss(
                       int    ldTicket,//-  
                       double ldOpen, //-  
                       double ldTake, //-  TakeProfit
                       double ldStop, //-  StopLoss  
                       )
  {
   bool   fm;
   fm=OrderModify(ldTicket,ldOpen,ldStop,ldTake,0,Blue);
   //if(fm && UseSound) PlaySound(NameFileSound);
  }
  
 //+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+   
void funAddText(
                int     iNumLine, // 
                string  sText,    // 
                color   cTextColor=White,//        
                int     iSizeFont=8,// 
                string  sTypeFont="Times New Roman" // 
                )
  {
//---
   long   chart_ID= 0;
   string sNumLine=gsAddToText+(string)iNumLine;//    
                                                //string name2     = "lblSpred";    
//string typeFont = "Times New Roman";
//int    sizeFont = 8;
   int    lblX     = 10;
   int    lblY     = iSizeFont*2;
//-------------------------------------
   ENUM_BASE_CORNER  corner=CORNER_RIGHT_UPPER; //    
   ENUM_ANCHOR_POINT anchor=ANCHOR_RIGHT_UPPER; //  
//-------------------------------------
   if(ObjectFind(chart_ID,sNumLine)==-1)
     {
      ObjectCreate(sNumLine,OBJ_LABEL,0,0,0);
      ObjectSet(sNumLine,OBJPROP_XDISTANCE,lblX);
      ObjectSet(sNumLine,OBJPROP_YDISTANCE,lblY+(iNumLine*15));
      ObjectSetInteger(chart_ID,sNumLine,OBJPROP_CORNER,corner);
      ObjectSetInteger(chart_ID,sNumLine,OBJPROP_ANCHOR,anchor);
     }
//---

   ObjectSetText(sNumLine,sText,iSizeFont,sTypeFont,cTextColor);
   ChartRedraw(chart_ID);

  }
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
void funDelALLText()
  {
//---    
   int obj_total=ObjectsTotal();

   for(int i=obj_total-1;i>=0;i--)
     {
      string name=ObjectName(i);

      if(StringFind(name,gsAddToText)!=-1)
         ObjectDelete(name);
     }
//return(0);
  }